<?php
  /**
  * Sistema Automatizado para la Planificación EstratÃ©gico-Situacional en la Administración Pública Venezolana
  * @file proyecto_operativo_seguimiento.module
  * Drupal part Module to code proyectos operativos module
  * Copyright 2012 Sistema Automatizado para la Planificación EstratÃ©gico-Situacional en la Administración PÃºblica Venezolana (CENDITEL)
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  * 
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  *
  * @author CENDITEL Merida - Ing. Diego Uzcategui
  * @date 2013-02-07 // (anno-mes-dia)
  * @author CENDITEL Merida - Phd Juan Vizcarrondo (Actualizacion de funciones)
  * @date 2016-12-14 // (anno-mes-dia)
  * @version 0.1
  *
  */

/**
 * funcion que muestra leyenda de colorimetria para estutus de ejecucion y estatus de inversion
 */
function _mostrarleyendazonacritica(){
  $output = '<br>';
  $rangos_descripcion = array();
  $rangos_descripcion[0] = '';//'No hay planificación'
  $rangos_descripcion[1] = t('(De 0 a 10.99 %)');//'Zona crítica'
  $rangos_descripcion[2] = t('(De 11 a 50.99 %)');//'Zona discreta'
  $rangos_descripcion[3] = t('(De 51 a 79.99 %)');//'Zona moderada'
  $rangos_descripcion[4] = t('(De 80 a 100 %)');//'Zona optima'
  $rangos_descripcion[5] = t('(Mas de 100 %)');//'Sobre ejecución'
  $settings['accion_especifica_de_proyecto_seguimiento'] = _cargarconfiguracioncolorimetria();
  $output .= '<table id="leyenda">';
  foreach($settings['accion_especifica_de_proyecto_seguimiento'] as $id => $zonacritica_i) {
    $output .= '<tr><td style="font-weight: bold">' .
    $zonacritica_i['texto'] . ' ' . $rangos_descripcion[$id] . '</td><td
style="background:' . $zonacritica_i['color'] . '; color:' . $zonacritica_i['tcolor'].';" width="50px">&nbsp;</td><tr>';
  }
  $output .= '</table>';
  return $output;
}

/**
 * funcion que retorna los datos de colorimetria para estutus de ejecucion y estatus de inversion
 */
function _calcularzonacritica($planificado, $ejecutado){
  $format_number = array(
    'decimals' => variable_get('proyectos_operativos_number_decimals', 0),
    'dec_point' => variable_get('proyectos_operativos_number_dec_point', ','),
    'thousands_sep' => variable_get('proyectos_operativos_number_thousands_sep', '.'),
  );
  $zonacritica = $planificado ? $ejecutado/$planificado : -1;
  $porczonacritica = $zonacritica >= 0 ? ($zonacritica * 100) . '%' : -1;
  $colorzona = variable_get('accion_especifica_de_proyecto_seguimiento_color_default', '#633303');
  $colorfontzona = variable_get('accion_especifica_de_proyecto_seguimiento_colort_default', '#FFFFFF');
  $textozona = variable_get('accion_especifica_de_proyecto_seguimiento_texto_default', 'No hay planificación');
  if ($porczonacritica >= 0 &&  $porczonacritica < 11) {
    $colorzona = variable_get('accion_especifica_de_proyecto_seguimiento_color_critica', '#fd0002');
    $textozona = variable_get('accion_especifica_de_proyecto_seguimiento_texto_critica', 'Zona crítica');
    $colorfontzona = variable_get('accion_especifica_de_proyecto_seguimiento_colort_critica', '#FFFFFF');
  }
  elseif ($porczonacritica >= 11 &&  $porczonacritica < 51) {
    $colorzona = variable_get('accion_especifica_de_proyecto_seguimiento_color_discreta', '#cc6733');
    $textozona = variable_get('accion_especifica_de_proyecto_seguimiento_texto_discreta', 'Zona discreta');
    $colorfontzona = variable_get('accion_especifica_de_proyecto_seguimiento_colort_discreta', '#FFFFFF');
  }
  elseif ($porczonacritica >= 51 &&  $porczonacritica < 80) {
    $colorzona = variable_get('accion_especifica_de_proyecto_seguimiento_color_moderada', '#fdff00');
    $textozona = variable_get('accion_especifica_de_proyecto_seguimiento_texto_moderada', 'Zona moderada');
    $colorfontzona = variable_get('accion_especifica_de_proyecto_seguimiento_colort_moderada', '#000000');
  }
  elseif ($porczonacritica >= 51 &&  $porczonacritica <= 100) {
    $colorzona = variable_get('accion_especifica_de_proyecto_seguimiento_color_optima', '#20ff21');
    $textozona = variable_get('accion_especifica_de_proyecto_seguimiento_texto_optima', 'Zona optima');
    $colorfontzona = variable_get('accion_especifica_de_proyecto_seguimiento_colort_optima', '#000000');
  }
  elseif ($porczonacritica > 100) {
    $colorzona = variable_get('accion_especifica_de_proyecto_seguimiento_color_sejecucion', '#9966cd');
    $textozona = variable_get('accion_especifica_de_proyecto_seguimiento_texto_sejecucion', 'Sobre ejecución');
    $colorfontzona = variable_get('accion_especifica_de_proyecto_seguimiento_colort_sejecucion', '#000000');
  }
  if ($porczonacritica < 0) {
    if ($ejecutado) {
      $porczonacritica = 'N/D';
      $colorzona = variable_get('accion_especifica_de_proyecto_seguimiento_color_sejecucion', '#9966cd');
      $textozona = variable_get('accion_especifica_de_proyecto_seguimiento_texto_sejecucion', 'Sobre ejecución');
      $colorfontzona = variable_get('accion_especifica_de_proyecto_seguimiento_colort_sejecucion', '#000000');
    }
    else {
      $porczonacritica = 'N/A';
    }
  }
  else {
    $porczonacritica = number_format($porczonacritica, 2, $format_number['dec_point'], $format_number['thousands_sep']);
  }
  $estatus_ejecucion_inversion = array(
    'porczonacritica' => $porczonacritica,
    'textozona' => $textozona,
    'colorzona' => $colorzona,
    'colorfontzona' => $colorfontzona,
  );
  return $estatus_ejecucion_inversion;
}

/**
 * funcion que muestra leyenda de colorimetria para estutus de ejecucion y estatus de inversion
 */
function _cargarconfiguracioncolorimetria(){
  $config_colorimetria = array(
    0 => array(
      'color' => variable_get('accion_especifica_de_proyecto_seguimiento_color_default', '#633303'),
      'tcolor' => variable_get('accion_especifica_de_proyecto_seguimiento_colort_default', '#FFFFFF'),
      'texto' => variable_get('accion_especifica_de_proyecto_seguimiento_texto_default', 'No hay planificación'),
    ),
    1 => array(
      'color' => variable_get('accion_especifica_de_proyecto_seguimiento_color_critica', '#fd0002'),
      'tcolor' => variable_get('accion_especifica_de_proyecto_seguimiento_colort_critica', '#FFFFFF'),
      'texto' => variable_get('accion_especifica_de_proyecto_seguimiento_texto_critica', 'Zona crítica'),
    ),
    2 => array(
      'color' => variable_get('accion_especifica_de_proyecto_seguimiento_color_discreta', '#cc6733'),
      'tcolor' => variable_get('accion_especifica_de_proyecto_seguimiento_colort_discreta', '#FFFFFF'),
      'texto' => variable_get('accion_especifica_de_proyecto_seguimiento_texto_discreta', 'Zona discreta'),
    ),
    3 => array(
      'color' => variable_get('accion_especifica_de_proyecto_seguimiento_color_moderada', '#fdff00'),
      'tcolor' => variable_get('accion_especifica_de_proyecto_seguimiento_colort_moderada', '#000000'),
      'texto' => variable_get('accion_especifica_de_proyecto_seguimiento_texto_moderada', 'Zona moderada'),
    ),
    4 => array(
      'color' => variable_get('accion_especifica_de_proyecto_seguimiento_color_optima', '#20ff21'),
      'tcolor' => variable_get('accion_especifica_de_proyecto_seguimiento_colort_moderada', '#000000'),
      'texto' => variable_get('accion_especifica_de_proyecto_seguimiento_texto_optima', 'Zona optima'),
    ),
    5 => array(
      'color' => variable_get('accion_especifica_de_proyecto_seguimiento_color_sejecucion', '#9966cd'),
      'tcolor' => variable_get('accion_especifica_de_proyecto_seguimiento_colort_sejecucion', '#000000'),
      'texto' => variable_get('accion_especifica_de_proyecto_seguimiento_texto_sejecucion', 'Sobre ejecución'),
    ),
  );
  return $config_colorimetria;
}
